varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform mediump vec2 pixelSize;

uniform lowp vec3 cl;
uniform lowp float width;

uniform lowp float diag;

void main(void)
{

	mediump vec4 front = texture2D(samplerFront, vTex);

	mediump float dx = pixelSize.x*width;
	mediump float dy = pixelSize.y*width;
  //lowp float diag = 0.7071;

  mediump float a0 = texture2D(samplerFront, vTex + vec2(-dx*diag, dy*diag)).a;
  mediump float a1 = texture2D(samplerFront, vTex + vec2(dx*diag, -dy*diag)).a;
  mediump float a2 = texture2D(samplerFront, vTex + vec2(-dx*diag, -dy*diag)).a;
  mediump float a3 = texture2D(samplerFront, vTex + vec2(dx*diag, dy*diag)).a;
  mediump float a4 = texture2D(samplerFront, vTex + vec2(-dx, 0.0)).a;
  mediump float a5 = texture2D(samplerFront, vTex + vec2(dx, 0.0)).a;
  mediump float a6 = texture2D(samplerFront, vTex + vec2(0.0, dy)).a;
  mediump float a7 = texture2D(samplerFront, vTex + vec2(0.0, -dy)).a;

  mediump float ina = max(max(max(max(max(max(max(a0,a1),a2),a3),a4),a5),a6),a7)-front.a;

	mediump float outa = ina + front.a*(1.0-ina);
	mediump vec3 outrgb = (vec3(cl.x, cl.y, cl.z)*ina + front.rgb*front.a*(1.0-ina));
	gl_FragColor = vec4(outrgb, outa);

}
